/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
	"time"
)

// checks if the ContactAllOfGivenConsents type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ContactAllOfGivenConsents{}

// ContactAllOfGivenConsents struct for ContactAllOfGivenConsents
type ContactAllOfGivenConsents struct {
	LastGivenAt *time.Time `json:"last_given_at,omitempty"`
	Version *int32 `json:"version,omitempty"`
}

// NewContactAllOfGivenConsents instantiates a new ContactAllOfGivenConsents object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewContactAllOfGivenConsents() *ContactAllOfGivenConsents {
	this := ContactAllOfGivenConsents{}
	return &this
}

// NewContactAllOfGivenConsentsWithDefaults instantiates a new ContactAllOfGivenConsents object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewContactAllOfGivenConsentsWithDefaults() *ContactAllOfGivenConsents {
	this := ContactAllOfGivenConsents{}
	return &this
}

// GetLastGivenAt returns the LastGivenAt field value if set, zero value otherwise.
func (o *ContactAllOfGivenConsents) GetLastGivenAt() time.Time {
	if o == nil || IsNil(o.LastGivenAt) {
		var ret time.Time
		return ret
	}
	return *o.LastGivenAt
}

// GetLastGivenAtOk returns a tuple with the LastGivenAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactAllOfGivenConsents) GetLastGivenAtOk() (*time.Time, bool) {
	if o == nil || IsNil(o.LastGivenAt) {
		return nil, false
	}
	return o.LastGivenAt, true
}

// HasLastGivenAt returns a boolean if a field has been set.
func (o *ContactAllOfGivenConsents) HasLastGivenAt() bool {
	if o != nil && !IsNil(o.LastGivenAt) {
		return true
	}

	return false
}

// SetLastGivenAt gets a reference to the given time.Time and assigns it to the LastGivenAt field.
func (o *ContactAllOfGivenConsents) SetLastGivenAt(v time.Time) {
	o.LastGivenAt = &v
}

// GetVersion returns the Version field value if set, zero value otherwise.
func (o *ContactAllOfGivenConsents) GetVersion() int32 {
	if o == nil || IsNil(o.Version) {
		var ret int32
		return ret
	}
	return *o.Version
}

// GetVersionOk returns a tuple with the Version field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactAllOfGivenConsents) GetVersionOk() (*int32, bool) {
	if o == nil || IsNil(o.Version) {
		return nil, false
	}
	return o.Version, true
}

// HasVersion returns a boolean if a field has been set.
func (o *ContactAllOfGivenConsents) HasVersion() bool {
	if o != nil && !IsNil(o.Version) {
		return true
	}

	return false
}

// SetVersion gets a reference to the given int32 and assigns it to the Version field.
func (o *ContactAllOfGivenConsents) SetVersion(v int32) {
	o.Version = &v
}

func (o ContactAllOfGivenConsents) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ContactAllOfGivenConsents) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.LastGivenAt) {
		toSerialize["last_given_at"] = o.LastGivenAt
	}
	if !IsNil(o.Version) {
		toSerialize["version"] = o.Version
	}
	return toSerialize, nil
}

type NullableContactAllOfGivenConsents struct {
	value *ContactAllOfGivenConsents
	isSet bool
}

func (v NullableContactAllOfGivenConsents) Get() *ContactAllOfGivenConsents {
	return v.value
}

func (v *NullableContactAllOfGivenConsents) Set(val *ContactAllOfGivenConsents) {
	v.value = val
	v.isSet = true
}

func (v NullableContactAllOfGivenConsents) IsSet() bool {
	return v.isSet
}

func (v *NullableContactAllOfGivenConsents) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableContactAllOfGivenConsents(val *ContactAllOfGivenConsents) *NullableContactAllOfGivenConsents {
	return &NullableContactAllOfGivenConsents{value: val, isSet: true}
}

func (v NullableContactAllOfGivenConsents) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableContactAllOfGivenConsents) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


